﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace malovani
{
    public partial class MainWindow : Form
    {
        public MainWindow()
        {
            InitializeComponent();
            comboBox1.SelectedIndex = 0;
            pictureBox_SizeChanged (null, null);
        }

        private void pictureBox_SizeChanged(object sender, EventArgs e)
        {
            Image old = pictureBox.Image;
            int W = pictureBox.Width;
            int H = pictureBox.Height;
            if (old != null)
            {
                if (W < old.Width) W = old.Width;
                if (H < old.Height) H = old.Height;
            }
            Image img = new Bitmap (W, H);
            Graphics g = Graphics.FromImage (img);
            Brush b = new SolidBrush (Color.White);
            g.FillRectangle (b, 0, 0, W, H);
            if (old != null)
                g.DrawImage (old, 0, 0);
            pictureBox.Image = img;
        }

        private void quitMenu_Click(object sender, EventArgs e)
        {
            Close ();
        }

        private void runMenu_Click(object sender, EventArgs e)
        {
            MainWindow w = new MainWindow ();
            w.Visible = true;
            /*
            Graphics g = Graphics.FromImage (pictureBox.Image);
            Pen p = new Pen (Color.Red);
            g.DrawLine (p, 10, 10, 100, 100);
            pictureBox.Invalidate ();
            */
        }

        int X0, Y0;
        bool click = false;
        Image save;

        private void pictureBox_MouseDown(object sender, MouseEventArgs e)
        {
            X0 = e.X;
            Y0 = e.Y;
            click = true;
            save = new Bitmap (pictureBox.Image);
        }

        const int line = 0;
        const int rectangle = 1;
        const int ellipse = 2;

        private void pictureBox_MouseMove(object sender, MouseEventArgs e)
        {
            if (click)
            {
                int tool = comboBox1.SelectedIndex;
                Graphics g = Graphics.FromImage (pictureBox.Image);
                g.DrawImage (save, 0, 0);
                switch (tool)
                {
                    case line:
                        g.DrawLine (pen, X0, Y0, e.X, e.Y);
                        break;
                    case rectangle:
                        g.FillRectangle (brush, X0, Y0, e.X-X0, e.Y-Y0);
                        g.DrawRectangle (pen, X0, Y0, e.X-X0, e.Y-Y0);
                        break;
                    case ellipse:
                        g.FillEllipse (brush, X0, Y0, e.X - X0, e.Y - Y0);
                        g.DrawEllipse (pen, X0, Y0, e.X - X0, e.Y - Y0);
                        break;
                }
                pictureBox.Invalidate ();
            }
        }
        private void pictureBox_MouseUp(object sender, MouseEventArgs e)
        {
            click = false;
        }

        Pen pen = new Pen (Color.Green);
        Brush brush = new SolidBrush (Color.Gray);

        private void panel1_MouseDown(object sender, MouseEventArgs e)
        {
            Panel p = (Panel) sender;

            if (e.Button == MouseButtons.Middle ||
                e.Button == MouseButtons.Left && Control.ModifierKeys == Keys.Control)
            {
                colorDialog1.Color = p.BackColor;
                if (colorDialog1.ShowDialog () == DialogResult.OK)
                {
                    p.BackColor = colorDialog1.Color;
                    pen = new Pen (p.BackColor);
                }
            }
            else if (e.Button == MouseButtons.Left)
                pen = new Pen (p.BackColor);
            else if (e.Button == MouseButtons.Right)
                brush = new SolidBrush (p.BackColor);
        }

        private int cnt = 1;

        private void newColorMenu_Click(object sender, EventArgs e)
        {
            Panel p = new Panel ();
            p.BackColor = Color.Orange;

            cnt ++;
            p.Left = panel1.Left + (cnt-1) * (panel1.Width + panel1.Left);
            p.Top = panel1.Top;
            p.Width = panel1.Width;
            p.Height = panel1.Height;

            p.MouseDown += panel1_MouseDown;

            toolbar.Controls.Add (p);
        }

    }
}
